﻿@using System.ComponentModel.DataAnnotations
@inject NavigationManager NavigationManager

<EditForm Model="loginModel" OnValidSubmit="Success">
  <DataAnnotationsValidator />
  <div>
    <p>
      <h3>Login</h3>
    </p>
    <p>
      <MatTextField Id="txtUsername" Label="Username" @bind-Value="loginModel.Username" Icon="perm_identity"/>
    </p>
    <p>
      <MatTextField Label="Password" @bind-Value="loginModel.Password" Type="password" Icon="vpn_key" />
    </p>
    <div class="mat-layout-grid-cell mat-layout-grid-cell-span-4">
      <MatButton Type="submit" Raised="true">Login</MatButton>
      <MatButton Raised="true" OnClick="Reset">Reset</MatButton>
    </div>
  </div>
</EditForm>

@code {

  [Inject]
  IJSRuntime JS { get; set; }

  protected override async Task OnAfterRenderAsync(bool firstRender) {
    if (firstRender) {
      await Focus("txtUsername");
    }
  }

  async Task Success() {

    if (loginModel.Username.ToLower() == "tptest" && loginModel.Password == "HalloWelt1!") {
      NavigationManager.NavigateTo("/counter");
    }
    else {
      await JS.InvokeVoidAsync("alert", "Incorrect Username or Passwort");
      await Reset();
    }
  }

  LoginModel loginModel = new LoginModel();

  async Task Reset() {
    loginModel.Username = null;
    loginModel.Password = null;
    await Focus("txtUsername");
  }

  public class LoginModel {
    [Required]
    public string Username { get; set; }

    [Required]
    public string Password { get; set; }
  }

  public async Task Focus(string elementId) {
    await JS.InvokeVoidAsync("focusElement", elementId);
  }

}